# __ASG_ClassDiagram.py_____________________________________________________
from ASG import *
from ATOM3Type       import *
from ATOM3String import *
class ASG_ClassDiagram(ASG, ATOM3Type):

   def __init__(self, parent= None, ASGroot = None):
      ASG.__init__(self, 'ClassDiagram', ASGroot, ['ASG_ClassDiagram' ,'AtomClass' ,'AtomAssociation' ,'Generalization'])

      ATOM3Type.__init__(self)
      self.parent = parent
      self.Title_=ATOM3String('Class Diagram')
      self.Author_=ATOM3String('')
      self.generatedAttributes = {'Title_': ('ATOM3String', ),
                                  'Author_': ('ATOM3String', )      }
      self.realOrder = ['Title_','Author_']
   def clone(self):
      return self
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
   def open(self, parent, topWindowParent):
       from ATOM3 import *
       a = ATOM3(topWindowParent, 'ClassDiagram', 0, 1, self)
       #self.writeContents(a)
       return a
   def preCondition (self, actionID, * params):
      if actionID == self.SAVE:
         res = self.assoc_names(params)
         if res: return res
      if actionID == self.SAVE:
         res = self.class_names(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def assoc_names(self, params):
      #Constraint to check that association names are unique
      
      nodes = self.listNodes    #getting the dictionnary of nodes
      
      assoc = nodes['AtomAssociation']   #getting the list of "AtomAssociation"
      
      for a in assoc:
         for b in assoc:
             if(a != b):
                 if(strip(a.name.getValue()) == strip(b.name.getValue())):  #strip removes blank spaces
                     return ("Associations names must be unique: " + a.name.toString(), a.name.toString())
      
      
      
      
      
      
      
      
      
      
      
      
      

   def class_names(self, params):
      #Constraint to check that class names are unique
      
      my_class = (self.listNodes)['AtomClass']   #getting the list of "AtomClass"
      
      for a in my_class:
         for b in my_class:
            if(a != b):
               if(strip(a.name.getValue()) == strip(b.name.getValue())):   #strip removes blank spaces
                   return ("Class names must be uniques: " + a.name.getValue(), a.name.getValue())
      
      
      
      
      
      
      
      
      
      
      
      
      



