# __AtomAssociation.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3Enum import *
from ATOM3String import *
from graph_AtomAssociation import *
class AtomAssociation(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_AtomAssociation
      self.parent = parent
      self.type=ATOM3Enum(['association', 'aggregation', 'composition'], 0, 0)
      self.name=ATOM3String('')
      self.From_multiplicity=ATOM3String('1..1')
      self.To_multiplicity=ATOM3String('1..1')
      self.generatedAttributes = {'type': ('ATOM3Enum', ),
                                  'name': ('ATOM3String', ),
                                  'From_multiplicity': ('ATOM3String', ),
                                  'To_multiplicity': ('ATOM3String', )      }
      self.realOrder = ['type','name','From_multiplicity','To_multiplicity']
   def clone(self):
      cloneObject = AtomAssociation( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT:
         res = self.set_variables(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def set_variables(self, params):
      Fm = self.From_multiplicity.getValue()
      Tm = self.To_multiplicity.getValue()
      
      tmpFm = split(Fm, '..', 2)
      tmpTm = split(Tm, '..', 2)
      
      try:
      	self.Fm = [1,1]
      	self.Tm = [1,1]
      	self.Fm[0] = int(tmpFm[0])
      	self.Fm[1] = int(tmpFm[1])
      	self.Tm[0] = int(tmpTm[0])
      	self.Tm[1] = int(tmpTm[1])
      
      except (ValueError, TypeError):
      	return ("Wrong cardinality syntax: should be number1..number2", (tmpFm, tmpTm))
      
      print self.Fm
      print self.Tm
      
      



