# __AtomClass.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3List import *
from ATOM3Boolean import *
from graph_AtomClass import *
class AtomClass(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_AtomClass
      self.parent = parent
      self.name=ATOM3String('My_class')
      self.class_methods=ATOM3List([ 1, 1, 1, 0],ATOM3String)
      lcobj0=[]
      self.class_methods.setValue(lcobj0)
      self.class_attribs=ATOM3List([ 1, 1, 1, 0],ATOM3String)
      lcobj0=[]
      self.class_attribs.setValue(lcobj0)
      self.atom_interface=ATOM3Boolean()
      self.atom_interface.setValue(('Is_Stereotyped?', 0))
      self.atom_interface.config = 0
      self.stereotype_appear=ATOM3String('<<interface>>')
      self.atom_abstract=ATOM3Boolean()
      self.atom_abstract.setValue(('Is_Abstract?', 0))
      self.atom_abstract.config = 0
      self.abstract_appear=ATOM3String('{abstract}')
      self.methods_appear=ATOM3String('')
      self.attrib_appear=ATOM3String('')
      self.generatedAttributes = {'name': ('ATOM3String', ),
                                  'class_methods': ('ATOM3List', 'ATOM3String'),
                                  'class_attribs': ('ATOM3List', 'ATOM3String'),
                                  'atom_interface': ('ATOM3Boolean', ),
                                  'stereotype_appear': ('ATOM3String', ),
                                  'atom_abstract': ('ATOM3Boolean', ),
                                  'abstract_appear': ('ATOM3String', ),
                                  'methods_appear': ('ATOM3String', ),
                                  'attrib_appear': ('ATOM3String', )      }
      self.realOrder = ['name','class_methods','class_attribs','atom_interface','stereotype_appear','atom_abstract','abstract_appear','methods_appear','attrib_appear']
   def clone(self):
      cloneObject = AtomClass( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if actionID == self.SAVE:
         res = self.Attrib_Names(params)
         if res: return res
      if actionID == self.SAVE:
         res = self.Method_Names(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if actionID == self.EDIT:
         res = self.method_creation(params)
         if res: return res
      if actionID == self.CREATE:
         res = self.create_variables(params)
         if res: return res
      if actionID == self.EDIT:
         res = self.attribs_creation(params)
         if res: return res
      if actionID == self.EDIT or actionID == self.CREATE or actionID == self.CONNECT or actionID == self.DISCONNECT:
         res = self.create_python_code(params)
         if res: return res
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def Attrib_Names(self, params):
      #Constraint that check that attributes/methods name are unique
      
      attrib_len = len(self.list_of_attribs.getValue()) #length of attrib list 
      attrib = self.list_of_attribs.getValue()   #get the attributes list
      methods = self.list_of_methods.getValue()  #get methods list
      
      attrib.extend(methods)  #combining the 2 lists
      
      for a in range(0, attrib_len):  #We only compare attrib<->attrib & attrib<->methods
        for b in range(0, len(attrib)):
          if(a != b):
            if(strip((attrib[a].getValue())[1].toString()) == 
                            strip((attrib[b].getValue())[1].toString())):  #strip removes blank spaces
               return ("Attribute/methods names must be unique in " + self.name.getValue(), 
                            attrib[a].getValue()[1].toString())
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      

   def Method_Names(self, params):
      #Constraint that checks that signatures are unique
      
      meth = self.list_of_methods.getValue()  #get the list of methods
      
      counter=0
      for a in meth:
        for b in meth:
          if(a != b):
            if((a.getValue())[1].toString() == (b.getValue())[1].toString()):  #if we name of the methods are equal
              if(len(a.getValue()) == len(b.getValue())):  #if the number of arguments are the same for both methods
                for i in range(len(a.getValue())-2):  #we check that each attribute type are not equal
                   if(strip(((a.getValue())[i+2].getValue())[0].toString()) == 
                                 strip(((b.getValue())[i+2].getValue())[0].toString())): 
                       counter = counter+1   
                if(counter == len(a.getValue())-2):
                     return ("Signatures must be unique in " + self.name.getValue(), self.name.getValue())
                else:
                     counter=0
                   
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      

   def method_creation(self, params):
      methods = self.class_methods.getValue()
      tokens=[]  #for temp values
      types=[]
      names=[]
      attribs=[]
      
      user_code = self.user_code
      
      
      #extracting the methods' types
      for a in methods:
      	if count(a.getValue(), "(") != 1 or count(a.getValue(), ")") != 1:
      		return ("Wrong method syntax, should be: type methodname(type attr1, type attr2, ..)", a.getValue())
      
      	currstr = string.split(strip(a.getValue()), None, 2) #current parsed value
      
      	if count(currstr[0], "(") != 0:
      		return ("Wrong method syntax, should be: type methodname(type attr1, type attr2, ..)", a.getValue())
      
      	if len(strip(currstr[0])) == 0 or len(strip(currstr[1])) == 0:
      		return ("Wrong method syntax, should be: type methodname(type attr1, type attr2, ..)", a.getValue())
      	types.append(currstr[0])
      	tokens.append(currstr[1])
      
      #extracting the methods' names
      for a in tokens:
      	name = string.split(a, '(', 2)
      	if len(strip(name[0])) == 0:
      		return ("Wrong method syntax, should be: type methodname(type attr1, type attr2, ..)", name)
      	names.append(name[0])
      
      tokens = tokens[len(tokens):]
      
      #extracting the methods' attributes
      for a in range(len(names)):
      	curr_meth = methods[a].getValue()   #the current method, i.e  int meth(int a, int b)
      	size=len(names[a])+len(types[a])+2  #size to remove from method to get 'int a, int b)'
      	curr_meth=curr_meth[:-1]  #to get int a, int b
      	tokens.append(strip(curr_meth[size:]))	
      		
      check=1  #check special case : only one attribute
      
      for a in tokens:
      	for b in range(len(a)):
      		if a[b] == ',':
      			check=0
      	if check:
      		attribs.append([a])
      	else:	
      		attribs.append(split(a, ', ', 100))
      
      for a in attribs:
      	for b in range(len(a)):
      		a[b] = strip(a[b])
      		a[b] = split(a[b], " ", 2)
      
      #We will now construct the datastructure from the user input
      #and update the internal variable  list_of_methods		
      
      meth_list = [] 
      
      for a in range(len(names)):
      	counter=0
      	meth_list.append(ATOM3List([1,1,1,0], None))
      	tmp=meth_list[a]
      	tmp.newItem(ATOM3String(types[a])) 
      	tmp.newItem(ATOM3String(names[a]))
      	for c in attribs[a]:
      		if c[0] != '':
      			tmp.newItem(ATOM3List([1,1,1,0], None))
      			tmp.getValue()[2+counter].newItem(ATOM3String(c[0]))
      			tmp.getValue()[2+counter].newItem(ATOM3String(c[1]))
      			counter=counter+1
      
      self.list_of_methods.setValue(meth_list)
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      

   def create_variables(self, params):
      self.list_of_methods = ATOM3List([1,1,1,0], None)
      self.list_of_attribs = ATOM3List([1,1,1,0], None)
      self.method_code = ATOM3List([1,1,1,0], None)  #will contains methods code, index correspond to list_of_methods
      self.attrib_code = ATOM3List([1,1,1,0], None)
      self.default_code = "\t\tpass\n"
      self.user_code = {}
      self.code = ATOM3String()  #String that contains the global class code
      self.code.setValue("Class My_class\n\tpass")
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      

   def attribs_creation(self, params):
      attribs = self.class_attribs.getValue()
      types=[]
      names=[]
      
      
      #splitting the type and method name.  i.e.  'int a' ==> ('int', 'a')
      for a in attribs:
      	types.append(string.split(strip(a.getValue()), None, 2)[0])
      	names.append(string.split(strip(a.getValue()), None, 2)[1])
      
      
      #building and updating the data-structure from user input
      attrib_list = []
      
      for a in range(len(names)):
      	attrib_list.append(ATOM3List([1,1,1,0], None))
      	tmp=attrib_list[a]
      	tmp.newItem(ATOM3String(types[a]))
      	tmp.newItem(ATOM3String(names[a]))
      
      self.list_of_attribs.setValue(attrib_list)
      		
      
      
      
      
      
      
      

   def create_python_code(self, params):
      #this constraint  set up default code-generation values
      #if the user did not specified code for the class methods
      
      class_name = self.name.toString()
      
      class_list_attrib = self.list_of_attribs.getValue()
      class_list_method = self.list_of_methods.getValue()
      class_code = self.code
      default_code = self.default_code
      user_code = self.user_code
      new_code = ""
      curr_sign = "" #we need it to check for the code to generate
      curr_key = ""  #the key that is mapped to code in the dictionnary
      
      new_code = new_code + "# " + class_name + ".py" " was generated by ATOM3. \n\n\n"
      new_code = new_code + "class " + class_name
      outcon = self.out_connections_
      
      #the following code is to generate inheritance code
      #if there is a parent connected via a 'Generalization'
      #relationship to this AtomClass
      #In python, the following code is generated : class child(parent1, parent2, ..)
      
      for a in range(len(outcon)):
      	if outcon[a].getTypeName() == 'Generalization' and a == 0:
      		for b in range(len(outcon[a].out_connections_)):  #scanning parents (mult inheritance allowed in python)
      			if outcon[a].out_connections_[b].getTypeName() == 'AtomClass' and b == 0:
      				new_code = new_code + "(" + outcon[a].out_connections_[b].name.getValue()
      			if outcon[a].out_connections_[b].getTypeName() == 'AtomClass' and b != 0:
      				new_code = new_code + ", " + outcon[a].out_connections_[b].name.getValue()
      	if outcon[a].getTypeName() == 'Generalization' and a != 0:
      		for b in range(len(outcon[a].out_connections_)):
      			if outcon[a].out_connections_[b].getTypeName() == 'AtomClass':
      				new_code = new_code + ", " + outcon[a].out_connections_[b].name.getValue()
      	if a == len(outcon)-1:
      		new_code = new_code + ")"
      
      new_code = new_code + ":\n\n"  #finishing with the class definition
      
      #the next code is for the attributes that were
      #defined by the user.  In python, we do not need
      #to explicitely define the variables, so default accessors are created.
      #for example, if the user declares "int a" , those methods are generated:
      #get_a() , set_a(value)
      
      for a in class_list_attrib:
      	curr_key = "set_" + a.getValue()[1].getValue() + "(self, value)"
      	new_code = new_code + "\tdef set_" + a.getValue()[1].getValue() + "(self, value):\n"
      	if(user_code.has_key(curr_key)):
      		new_code = new_code + user_code[curr_key]	
      	else:
      		new_code = new_code + "\t\tself." + a.getValue()[1].getValue() + " = value\n\n"
      	curr_key = "get_" + a.getValue()[1].getValue() + "()"
      	new_code = new_code + "\tdef get_" + a.getValue()[1].getValue() + "():\n"
      	if(user_code.has_key(curr_key)):
      		new_code = new_code + user_code[curr_key]
      	else:
      		new_code = new_code + "\t\treturn self." + a.getValue()[1].getValue() + "\n\n"
      
      #the next code is for the default python constructor  __init__
      #the default constructor initialize all the attributes that were
      #declared by the user
      
      for b in range(len(class_list_attrib)):
      	if(b == 0):
      		constructor =  "\tdef __init__(" + class_list_attrib[b].getValue()[1].getValue()
      	else:
      		constructor = constructor + ", " + class_list_attrib[b].getValue()[1].getValue()
      if(len(class_list_attrib) != 0):	
      	new_code = new_code + constructor + ")" + "\n"
      	for b in range(len(class_list_attrib)):
      		new_code = new_code + "\t\tself." + class_list_attrib[b].getValue()[1].getValue() + " = " + class_list_attrib[b].getValue()[1].getValue() + "\n"
      else:
      	new_code = new_code + "\tdef __init__()\n"
      	new_code = new_code + "\t\tpass\n"
      
      #the next code generates user defined methods
      
      for a in range(len(class_list_method)):
      	
      	curr_meth=class_list_method[a].getValue()   #method currently written
      	curr_sign = curr_sign + "\tdef " + curr_meth[1].getValue() + "("
      	#writing attributes, if they exists
      	if len(curr_meth) > 2:
      		curr_sign = curr_sign + "self, " + curr_meth[2].getValue()[1].getValue()
      		curr_meth = curr_meth[3:]  #remove 3 elements (type, method name, 1st attrib)	
      		for b in curr_meth:   #scan method's remaining attributes
      			curr_sign = curr_sign + ", " + b.getValue()[1].getValue()
      	curr_sign = curr_sign + ")"
      	curr_key = curr_sign.replace("def", "")
      	curr_key = curr_key.replace("\n", "")
      	curr_key = curr_key.replace("\t", "")
      	curr_key = curr_key.replace(":", "")
      	curr_key = strip(curr_key)
      	if(user_code.has_key(curr_key)):
      		new_code = new_code + curr_sign + "\n" + user_code[curr_key]
      	else:
      		new_code = new_code + curr_sign + "\n" + default_code
      	new_code = new_code + "\n"
      	curr_sign = ""
      
      class_code.setValue(new_code)
      
      
      
      
      
      
      



