from graphEntity          import *
from GraphicalForm   import *
from ATOM3Constraint import *

class graph_AtomClass(graphEntity):

    def __init__(self, x, y, semObject = None):
        self.semanticObject = semObject
        self.sizeX, self.sizeY = 208, 229
        graphEntity.__init__(self, x, y)
        self.constraintList = []
        if self.semanticObject: atribs = self.semanticObject.attributesToDraw()
        else: atribs = None
        constObj = ATOM3Constraint(atribs,"attrib_constr","self.semanticObject.", [], [])
        constObj.setValue(('attrib_constr', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'list = self.semanticObject.class_attribs.getValue()\ntmpString = ""\nfor a in list:\n\ttmpString = tmpString + a.getValue() + \'\\n\'\nself.semanticObject.attrib_appear.setValue(tmpString)\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n'))
        self.constraintList.append(constObj)

        constObj = ATOM3Constraint(atribs,"abstract","self.semanticObject.", [], [])
        constObj.setValue(('abstract', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), '#set up the appearance depending if abstract property is on\n\nabs = self.semanticObject.atom_abstract.getValue()  #abs value\n\nself.gf13.setVisible(abs[1])\n\n  \n\n\n\n\n\n\n\n\n\n\n\n\n'))
        self.constraintList.append(constObj)

        constObj = ATOM3Constraint(atribs,"interface","self.semanticObject.", [], [])
        constObj.setValue(('interface', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0]), '#set up the appearance depending if abstract property is on\n\ninter = self.semanticObject.atom_interface.getValue()  #interface value\n\nself.gf12.setVisible(inter[1])\n\n\n\n\n\n\n'))
        self.constraintList.append(constObj)

        constObj = ATOM3Constraint(atribs,"method_constr","self.semanticObject.", [], [])
        constObj.setValue(('method_constr', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), 'list = self.semanticObject.class_methods.getValue()\ntmpString = ""\nfor a in list:\n\ttmpString = tmpString + a.getValue() + \'\\n\'\n\nself.semanticObject.methods_appear.setValue(tmpString)\n\n\n\n\n\n\n'))
        self.constraintList.append(constObj)

        constObj = ATOM3Constraint(atribs,"general_appear","self.semanticObject.", [], [])
        constObj.setValue(('general_appear', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), '#set up general appearance constraints\n\nprint str(self.semanticObject.attrib_appear)\n\nif(self.semanticObject.attrib_appear.toString() == ""):\n   self.gf15.setVisible(0)\nelse:\n   self.gf15.setVisible(1)\n\nif(self.semanticObject.methods_appear.toString() == ""):\n   self.gf14.setVisible(0)\nelse:\n   self.gf14.setVisible(1)\n\nif(self.semanticObject.stereotype_appear.toString() == ""):\n   self.gf12.setVisible(0)\n\nif(self.semanticObject.abstract_appear.toString() == ""):\n   self.gf13.setVisible(0)\n\nif(self.semanticObject.name.toString() == ""):\n   self.gf11.setVisible(0)\nelse:\n   self.gf11.setVisible(1)\n\n\n\n\n\n\n\n'))
        self.constraintList.append(constObj)

        self.graphForms = []

    def DrawObject(self, drawing, showGG = 0):
        self.dc = drawing
        if showGG and self.semanticObject: self.drawGGLabel(drawing)
        h = drawing.create_rectangle(self.translate([5.0, 2.0, 205.0, 225.0]), tags = self.tag, stipple= '', width= '1.0', outline= 'black', fill= '')
        self.gf8 = GraphicalForm(drawing, h, "gf8")
        self.graphForms.append(self.gf8)
        h = drawing.create_line(self.translate([7.0, 40.0, 204.0, 40.0]), tags = self.tag, stipple= '', width= '1.0', splinesteps= '12', arrowshape= '8 10 3', arrow= 'none', capstyle= 'butt', smooth= 0, joinstyle= 'round', fill= 'black')
        self.gf9 = GraphicalForm(drawing, h, "gf9")
        self.graphForms.append(self.gf9)
        h = drawing.create_line(self.translate([5.0, 129.0, 205.0, 129.0]), tags = self.tag, stipple= '', width= '1.0', splinesteps= '12', arrowshape= '8 10 3', arrow= 'none', capstyle= 'butt', smooth= 0, joinstyle= 'round', fill= 'black')
        self.gf10 = GraphicalForm(drawing, h, "gf10")
        self.graphForms.append(self.gf10)
        h = drawing.create_oval(self.translate([205.0, 129.0, 205.0, 129.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([101.0, 226.0, 101.0, 226.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([5.0, 129.0, 5.0, 129.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        h = drawing.create_oval(self.translate([101.0, 3.0, 101.0, 3.0]), tags = (self.tag, "connector"), stipple= '', width= '1.0', outline= 'black', fill= 'red')
        self.connectors.append(h)
        if self.semanticObject: drawText = self.semanticObject.stereotype_appear.toString(25,5)
        else: drawText = "<stereotype_appear>"
        h = drawing.create_text(self.translate([98.0, 8.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'blue', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["stereotype_appear"] = h
        self.gf12 = GraphicalForm(drawing, h, "gf12")
        self.graphForms.append(self.gf12)
        if self.semanticObject: drawText = self.semanticObject.abstract_appear.toString(25,5)
        else: drawText = "<abstract_appear>"
        h = drawing.create_text(self.translate([96.0, 34.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'blue', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["abstract_appear"] = h
        self.gf13 = GraphicalForm(drawing, h, "gf13")
        self.graphForms.append(self.gf13)
        if self.semanticObject: drawText = self.semanticObject.methods_appear.toString(25,5)
        else: drawText = "<methods_appear>"
        h = drawing.create_text(self.translate([54.0, 187.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'blue', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["methods_appear"] = h
        self.gf14 = GraphicalForm(drawing, h, "gf14")
        self.graphForms.append(self.gf14)
        if self.semanticObject: drawText = self.semanticObject.attrib_appear.toString(25,5)
        else: drawText = "<attrib_appear>"
        h = drawing.create_text(self.translate([44.0, 93.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'blue', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["attrib_appear"] = h
        self.gf15 = GraphicalForm(drawing, h, "gf15")
        self.graphForms.append(self.gf15)
        if self.semanticObject: drawText = self.semanticObject.name.toString(25,5)
        else: drawText = "<name>"
        h = drawing.create_text(self.translate([97.0, 22.0]), tags = self.tag, text = drawText, stipple= '', width= '0', fill= 'blue', font= 'Helvetica -12', anchor= 'center', justify= 'left')
        self.attr_display["name"] = h
        self.gf11 = GraphicalForm(drawing, h, "gf11")
        self.graphForms.append(self.gf11)

    def attrib_constr(self):
       list = self.semanticObject.class_attribs.getValue()
       tmpString = ""
       for a in list:
       	tmpString = tmpString + a.getValue() + '\n'
       self.semanticObject.attrib_appear.setValue(tmpString)
       
       
       
       
       
       
       
       
       
       
       
       
       
       
       
       
       
       
       
       
       
       
       
    def abstract(self):
       #set up the appearance depending if abstract property is on
       
       abs = self.semanticObject.atom_abstract.getValue()  #abs value
       
       self.gf13.setVisible(abs[1])
       
         
       
       
       
       
       
       
       
       
       
       
       
       
       
    def interface(self):
       #set up the appearance depending if abstract property is on
       
       inter = self.semanticObject.atom_interface.getValue()  #interface value
       
       self.gf12.setVisible(inter[1])
       
       
       
       
       
       
       
    def method_constr(self):
       list = self.semanticObject.class_methods.getValue()
       tmpString = ""
       for a in list:
       	tmpString = tmpString + a.getValue() + '\n'
       
       self.semanticObject.methods_appear.setValue(tmpString)
       
       
       
       
       
       
       
    def general_appear(self):
       #set up general appearance constraints
       
       print str(self.semanticObject.attrib_appear)
       
       if(self.semanticObject.attrib_appear.toString() == ""):
          self.gf15.setVisible(0)
       else:
          self.gf15.setVisible(1)
       
       if(self.semanticObject.methods_appear.toString() == ""):
          self.gf14.setVisible(0)
       else:
          self.gf14.setVisible(1)
       
       if(self.semanticObject.stereotype_appear.toString() == ""):
          self.gf12.setVisible(0)
       
       if(self.semanticObject.abstract_appear.toString() == ""):
          self.gf13.setVisible(0)
       
       if(self.semanticObject.name.toString() == ""):
          self.gf11.setVisible(0)
       else:
          self.gf11.setVisible(1)
       
       
       
       
       
       
       
       

    def postCondition (self, actionID, * params):
       if actionID ==  self.EDIT:
         res = self.attrib_constr()
         if res: return res
       if actionID ==  self.EDIT or actionID == self.CREATE:
         res = self.abstract()
         if res: return res
       if actionID ==  self.EDIT or actionID == self.CREATE:
         res = self.interface()
         if res: return res
       if actionID ==  self.EDIT:
         res = self.method_constr()
         if res: return res
       if actionID ==  self.EDIT:
         res = self.general_appear()
         if res: return res
       return None

    def preCondition (self, actionID, * params):
       return None


new_class = graph_AtomClass
